{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+}
unit StandInp;   {ellenrztt input}
interface
 uses Crt,SzovKez,StandDef,StandKom;
 {ltalnos szveg }
 procedure SzovegBe(var Szoveg       :string; {i/o eredmny szveg }
                        Oszl,Sor     :Byte;   {i kpernypozici }
                        AdatJel      :Jelek;  {i adatjelek}
                        MinAdh,MaxAdh:Byte;   {i min,max adathossz}
                        ElvJel       :Jelek;  {i elvlaszt jelek}
                        MinEDb,MaxEDb:Byte;   {i min,max elvlaszt jel db.}
                    var VanAdat      :Boolean {o van-e uj adat });
 { Longint }
 procedure EgSzamBe(var SzamSzov  :string;     {i/o eredmny szveg }
                        Oszl,Sor  :Byte;       {i   kpernypozici }
                        Tol,Ig    :Longint;    {i  hatrok         }
                    var VanAdat   :Boolean;    {o  van-e uj adat   }
                    var SzamErt   :Longint     {o  eredmny szm  });
 { Real }
 procedure ValSzamBe(var SzamSzov  :string;    {i/o eredmny szveg }
                         Oszl,Sor  :Byte;      {i   kpernypozici }
                         Tol,Ig    :Real;      {i   hatrok         }
                         MaxH      :Byte;      {i   mezhossz       }
                     var VanAdat   :Boolean;   {o                   }
                     var szamert   :Real       {o   eredmny szm   });

implementation
 procedure KiIras(s:string;Oszl,Sor,Hossz:Byte;Irmod:IrasMod);
  {ir s cursort visszallit Oszl+Hossz -ra}
 begin
  case Irmod of
   Normal:NormalIr;
   Inverz:InverzIr;
  end;
  Ir(s,Oszl,Sor);GotoXY(Oszl+Hossz,Sor);
 end;

 procedure SzovegBe;
  var
   Jel  :Char; {aktulis jel}   JoJel:Jelek; {aktulis jelhalmaz}
   Hossz:Byte; {aktulis Hossz} ElvDb:Byte;  {aktulis elv.jel db.}
   i:Byte;
 begin
  {elkszts}
  {adat}
  Hossz:=Length(Szoveg); Szoveg:=JobbTolt(Szoveg,MaxAdh);
  ElvDb:=0;
  if Hossz>0 then begin
   for i:=1 to Hossz do if Szoveg[i] in ElvJel then Inc(ElvDb);
   Jel:=Szoveg[Hossz];
  end;
  {kperny}
  if Oszl=0 then Oszl:=WhereX; if Sor=0 then Sor:=WhereY;
  Uzen(InpUzen); KiIras(Szoveg,Oszl,Sor,Hossz,Inverz);
  {beolvass}
  repeat
   {jojel bellts}
   {kilps}
   JoJel:=[KiLep];
   {norml jelek}
   if Hossz<MaxAdh then JoJel:=JoJel+AdatJel;
   {elvlaszt jelek}
   if (Hossz>0) and (Hossz<MaxAdh-1) and
      not (Jel in ElvJel) and (ElvDb<MaxEDb) then JoJel:=JoJel+ElvJel;
   {visszatrls}
   if Hossz>0 then JoJel:=JoJel+[Torol];
   {adatvg}
   if (Hossz>=MinAdh) and not (Jel in ElvJel) and
       (ElvDb>=MinEDb) then JoJel:=JoJel+[AdatVeg];
   {jel beolvass}
   Jel:=JelBe(JoJel);
   {jel feldolgozs}
   {norml jelek}
   if Jel in AdatJel then begin Hossz:=Hossz+1;Szoveg[Hossz]:=Jel end
   else  {elvlaszt jelek}
   if Jel in ElvJel then begin
    Hossz:=Hossz+1;ElvDb:=ElvDb+1; Szoveg[Hossz]:=Jel
   end else {visszatrls}
   if Jel=Torol then begin
    if Szoveg[Hossz] in ElvJel then ElvDb:=ElvDb-1;
    Szoveg[Hossz]:=Ures; Hossz:=Hossz-1;
    if Hossz>0 then Jel:=Szoveg[Hossz];
   end;
   KiIras(Szoveg,Oszl,Sor,Hossz,Marad);
  until (Jel in [KiLep,AdatVeg]);
  {befejezs}
  KiIras(JobbTolt('',MaxAdh),Oszl,Sor,MaxAdh,Normal);
  VanAdat:=Jel<>KiLep;
  if VanAdat then Szoveg[0]:=Chr(Hossz) else Szoveg:='';
  KiIras(Szoveg,Oszl,Sor,Hossz,Normal);  Uzen('');
 end;

 procedure EgSzamBe;
  var
   Jel  :Char;  {aktulis jel}       Hossz :EgSzamHossz;{aktulis Hossz}
   JoJel:Jelek; {aktulis jelhalmaz} JoSzam:Boolean;{tartomny helyessg}
   w:string; MaxH :EgSzamHossz; i:Integer; x: Longint;
 begin
  {elkszts}
  {adat}
  Str(Tol,w); MaxH:=Length(w); Str(Ig,w);
  if MaxH<Length(w) then MaxH:=Length(w);
  Hossz:=Length(SzamSzov);SzamSzov:=JobbTolt(SzamSzov,MaxH);
  {kperny}
  if Oszl=0 then Oszl:=WhereX; if Sor=0 then Sor:=WhereY;
  Uzen(InpUzen); KiIras(SzamSzov,Oszl,Sor,Hossz,Inverz);
  {beolvass}
  repeat {msodik szint: rtktartomny}
   repeat {els szint: csak szm}
    {jjel bellts}
    {kilps}
    JoJel:=[KiLep];
    {norml jelek}
    if Hossz<MaxH then JoJel:=JoJel+SzamJegyek;
    if (Hossz=0) and (Tol<0) then JoJel:=JoJel+[Elojel];
    {visszatrls}
    if Hossz>0 then JoJel:=JoJel+[Torol];
    {adatvg}
    if (Hossz>0) and (SzamSzov[Hossz] in SzamJegyek) then JoJel:=JoJel+[AdatVeg];
    {jel beolvass}
    Jel:=JelBe(JoJel);
    {jel feldolgozs}
    {norml jelek}
    if (Jel in SzamJegyek) or (Jel=Elojel) then begin
     Hossz:=Hossz+1;SzamSzov[Hossz]:=Jel
    end else {visszatrls}
    if Jel=Torol then begin
     SzamSzov[Hossz]:=Ures; Hossz:=Hossz-1;
    end;
    KiIras(SzamSzov,Oszl,Sor,Hossz,Marad);
   until (Jel in [KiLep,AdatVeg]);
   {tartomny ellenrzs}
   if Jel<>KiLep then Val(Copy(SzamSzov,1,Hossz),x,i) ;
   JoSzam:=(i=0) and (x>=Tol) and (x<=Ig);
  until (Jel=KiLep) or JoSzam;
  {befejezs}
  VanAdat:=Jel<>KiLep;
  KiIras(JobbTolt('',MaxH),Oszl,Sor,MaxH,Normal);
  if VanAdat then begin
   SzamSzov[0]:=Chr(Hossz); SzamErt:=x;
  end
  else SzamSzov:='';
  KiIras(SzamSzov,Oszl,Sor,Hossz,Normal); Uzen('');
 end;

 procedure ValSzamBe;
  var
   Jel  :Char;{aktulis jel}   JoJel   :Jelek;   {aktulis jelhalmaz}
   Hossz:Byte;{aktulis Hossz} w:string; {szveg munkaterlet}
   JoSzam  :Boolean; {tartalmi helyessg}
   VoltPont:Boolean; {volt-e tizedespont}
   i:integer; x:Real;
 begin
  {elkszts}
  Str(Trunc(Tol),w); if Length(w)>MaxH then MaxH:=Length(w);
  Str(Trunc(Ig ),w); if Length(w)>MaxH then MaxH:=Length(w);
  Hossz:=Length(SzamSzov);SzamSzov:=JobbTolt(SzamSzov,MaxH);
  if Hossz>0 then Jel:=SzamSzov[Hossz];
  VoltPont:=Pos(TPont,SzamSzov)>0;
  {kperny}
  if Oszl=0 then Oszl:=WhereX; if Sor=0 then Sor:=WhereY;
  Uzen(InpUzen); KiIras(SzamSzov,Oszl,Sor,Hossz,Inverz);
  {beolvass}
  repeat {msodik szint: rtktartomny}
   repeat {els szint: csak szm}
    {JoJel bellts}
    {kilps}
    JoJel:=[Kilep];
    {norml jelek}
    if (Hossz=0) and (Tol<0) then JoJel:=JoJel+[Elojel];
    if (Hossz>0) and (Hossz<MaxH) and not VoltPont
        then JoJel:=JoJel+[TPont];
    if Hossz<MaxH then JoJel:=JoJel+SzamJegyek;
    {visszatrls}
    if Hossz>0 then JoJel:=JoJel+[Torol];
    {adatvg}
    if Jel in SzamJegyek+[TPont] then JoJel:=JoJel+[AdatVeg];
    {Jel beolvass}   Jel:=jelbe(JoJel);
    {Jel feldolgozs}
    {norml jelek}
     if Jel in (SzamJegyek+[TPont,Elojel]) then begin
      inc(Hossz);SzamSzov[Hossz]:=Jel;
      VoltPont:=VoltPont or (Jel=TPont);
     end else
    {visszatrls}
     if Jel=Torol then begin
      VoltPont:=VoltPont and (SzamSzov[Hossz]<>TPont);
      SzamSzov[Hossz]:=ures; dec(Hossz);
      if Hossz>0 then Jel:=SzamSzov[Hossz];
     end;
     KiIras(SzamSzov,Oszl,Sor,Hossz,marad);
   until (Jel in [Kilep,AdatVeg]);
   if Jel<>Kilep then Val(Copy(SzamSzov,1,Hossz),x,i) ;
   JoSzam:=(i=0) and (x>=Tol) and (x<=Ig);
  until (Jel=Kilep) or JoSzam;
  {befejezs}
  VanAdat:=Jel<>Kilep;
  KiIras(JobbTolt('',MaxH),Oszl,Sor,MaxH,Normal);
  if VanAdat then begin
   SzamSzov[0]:=Chr(Hossz); SzamErt:=x;
  end
  else SzamSzov:='';
  KiIras(SzamSzov,Oszl,Sor,Hossz,Normal);  Uzen('');
 end;
end.
